#ifndef PIECE
#define PIECE

#include <string>

#include "Color.hpp"

enum PieceType {NOT_A_TYPE, PAWN, KNIGHT, BISHOP, ROOK, QUEEN, KING};

class Piece {
public:
    Piece(); // to remove
    Piece(const Color&, const PieceType&);

    Color color;
    PieceType type;

    std::string to_fen() const;

    static Piece from_fen(std::string);

    bool operator==(const Piece&) const;
    bool operator!=(const Piece&) const;
};

#endif
