#ifndef CST
#define CST

#include <iostream>
#include <iomanip>
#include <mutex>

#include "Platform.hpp"

std::mutex out_mutex;

UNumber check_counter = 0;
UNumber failed_counter = 0;
UNumber passed_counter = 0;

std::string firsts(std::string old) {
	return old.substr(0,35) + "...";
}

#define CHECK(expr) { \
    out_mutex.lock(); \
    using namespace std; \
    check_counter++; \
    if (check_counter == 1) { \
        cout << "Starting tests...\n"; \
    } else {}; \
    if (expr) { \
        cout << "    Passed "; \
        passed_counter++; \
    } else { \
        cout << "!!! Failed "; \
        failed_counter++; \
    } \
    cout << "Test #" \
        << setfill('0') << setw(4) << (check_counter) \
		<< " (" << firsts(#expr) << ")\n"; \
    out_mutex.unlock(); \
}

#define EXCEPTION(expr) { \
    out_mutex.lock(); \
    using namespace std; \
    check_counter++; \
    if (check_counter == 1) { \
        cout << "Starting tests...\n"; \
    } else {}; \
    try { \
        expr; \
        cout << "!!! Failed "; \
        failed_counter++; \
    } catch (...) { \
        cout << "    Passed "; \
        passed_counter++; \
    } \
    cout << "Exception Test #" \
        << setfill('0') << setw(4) << (check_counter) \
		<< " (" << firsts(#expr) << ")\n"; \
    out_mutex.unlock(); \
}

#define RESULTS { \
    using namespace std; \
    cout << "Passed " << passed_counter << "/" << check_counter << ".\n"; \
    if (failed_counter == 0) {cout << "All tests passed.\n";} \
    else {cout << "Failed " << failed_counter << " tests.\n";} \
}

#endif
